Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.swing.text
Class ParagraphView

    java.lang.Object
      |
      +--javax.swing.text.View
            |
            +--javax.swing.text.CompositeView
                  |
                  +--javax.swing.text.BoxView
                        |
                        +--javax.swing.text.FlowView
                              |
                              +--javax.swing.text.ParagraphView

All Implemented Interfaces:
  SwingConstants, TabExpander

Direct Known Subclasses:
  ParagraphView

public class ParagraphView
extends FlowView
implements TabExpander

View of a simple line-wrapping paragraph that supports multiple fonts, colors, components, icons, etc. It is basically a vertical box with a margin around it. The contents of the box are a bunch of rows which are special horizontal boxes. This view creates a collection of views that represent the child elements of the paragraph element. Each of these views are placed into a row directly if they will fit, otherwise the `breakView` method is called to try and carve the view into pieces that fit.

See Also:
  `View`

Inner classes inherited from class javax.swing.text.FlowView
`FlowView.FlowStrategy`

Field Summary
`protected int` | `firstLineIndent` Indentation for the first line, from the left inset.

Fields inherited from class javax.swing.text.FlowView
`layoutPool, layoutSpan, strategy`

Fields inherited from class javax.swing.text.View
`BadBreakWeight, ExcellentBreakWeight, ForcedBreakWeight, GoodBreakWeight, X_AXIS, Y_AXIS`

Fields inherited from interface javax.swing.SwingConstants
`BOTTOM, CENTER, EAST, HORIZONTAL, LEADING, LEFT, NORTH, NORTH_EAST, NORTH_WEST, RIGHT, SOUTH, SOUTH_EAST, SOUTH_WEST, TOP, TRAILING, VERTICAL, WEST`

Constructor Summary
`ParagraphView(Element elem)` Constructs a ParagraphView for the given element.

Method Summary
`protected void` | `adjustRow(javax.swing.text.ParagraphView.Row r, int desiredSpan, int x)` Adjusts the given row if possible to fit within the layout span.
`View` | `breakView(int axis, float len, Shape a)` Breaks this view on the given axis at the given length.
`void` | `changedUpdate(DocumentEvent changes, Shape a, ViewFactory f)` Gives notification from the document that attributes were changed in a location that this view is responsible for.
`protected View` | `createRow()` Create a View that should be used to hold a a rows worth of children in a flow.
`protected int` | `findOffsetToCharactersInString(char[] string, int start)` Finds the next character in the document with a character in `string`, starting at offset `start`.
`protected boolean` | `flipEastAndWestAtEnds(int position, Position.Bias bias)` Subclasses may wish to subclass this and conditionally return true based on the position.
`float` | `getAlignment(int axis)` Determines the desired alignment for this view along an axis.
`int` | `getBreakWeight(int axis, float len)` Gets the break weight for a given location.
`protected int` | `getClosestPositionTo(int pos, Position.Bias b, Shape a, int direction, Position.Bias[] biasRet, int rowIndex, int x)` Returns the closest model position to `x`.
`int` | `getFlowSpan(int index)` Fetch the constraining span to flow against for the given child index.
`int` | `getFlowStart(int index)` Fetch the location along the flow axis that the flow span will start at.
`protected View` | `getLayoutView(int index)` The child views of the paragraph are rows which have been used to arrange pieces of the Views that represent the child elements.
`protected int` | `getLayoutViewCount()` The child views of the paragraph are rows which have been used to arrange pieces of the Views that represent the child elements.
`protected int` | `getNextNorthSouthVisualPositionFrom(int pos, Position.Bias b, Shape a, int direction, Position.Bias[] biasRet)` Overriden from CompositeView.
`protected float` | `getPartialSize(int startOffset, int endOffset)` Returns the size used by the views between `startOffset` and `endOffset`.
`protected float` | `getTabBase()`
`protected TabSet` | `getTabSet()` Gets the Tabset to be used in calculating tabs.
`float` | `nextTabStop(float x, int tabOffset)` Returns the next tab stop position given a reference position.
`void` | `paint(Graphics g, Shape a)` Renders using the given rendering surface and area on that surface.
`protected void` | `setFirstLineIndent(float fi)` Set the indent on the first line
`protected void` | `setJustification(int j)` Set the type of justification.
`protected void` | `setLineSpacing(float ls)` Set the line spacing.
`protected void` | `setPropertiesFromAttributes()`

Methods inherited from class javax.swing.text.FlowView
`calculateMinorAxisRequirements, getFlowAxis, getViewIndexAtPosition, insertUpdate, layout, loadChildren, removeUpdate`

Methods inherited from class javax.swing.text.BoxView
`baselineLayout, baselineRequirements, calculateMajorAxisRequirements, childAllocation, forwardUpdate, getAxis, getChildAllocation, getHeight, getMaximumSpan, getMinimumSpan, getOffset, getPreferredSpan, getResizeWeight, getSpan, getViewAtPoint, getWidth, isAfter, isAllocationValid, isBefore, layoutChanged, layoutMajorAxis, layoutMinorAxis, modelToView, paintChild, preferenceChanged, replace, setAxis, setSize, viewToModel`

Methods inherited from class javax.swing.text.CompositeView
`getBottomInset, getInsideAllocation, getLeftInset, getNextEastWestVisualPositionFrom, getNextVisualPositionFrom, getRightInset, getTopInset, getView, getViewAtPosition, getViewCount, getViewIndex, modelToView, setInsets, setParagraphInsets, setParent`

Methods inherited from class javax.swing.text.View
`append, breakView, createFragment, forwardUpdateToView, getAttributes, getBreakWeight, getContainer, getDocument, getElement, getEndOffset, getGraphics, getParent, getStartOffset, getViewFactory, insert, isVisible, modelToView, remove, removeAll, updateChildren, updateLayout, viewToModel`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### firstLineIndent

    protected int firstLineIndent

  Indentation for the first line, from the left inset.

Constructor Detail

### ParagraphView

    public ParagraphView(Element elem)

  Constructs a ParagraphView for the given element.
  Parameters:
    `elem` - the element that this view is responsible for

Method Detail

### setJustification

    protected void setJustification(int j)

  Set the type of justification.

### setLineSpacing

    protected void setLineSpacing(float ls)

  Set the line spacing.
  Parameters:
    `ls` - the value in points

### setFirstLineIndent

    protected void setFirstLineIndent(float fi)

  Set the indent on the first line
  Parameters:
    `ls` - the value in points

### setPropertiesFromAttributes

    protected void setPropertiesFromAttributes()

### getLayoutViewCount

    protected int getLayoutViewCount()

  The child views of the paragraph are rows which have been used to arrange pieces of the Views that represent the child elements. This is the number of views that have been tiled in two dimensions, and should be equivalent to the number of child elements to the element this view is responsible for.

### getLayoutView

    protected View getLayoutView(int index)

  The child views of the paragraph are rows which have been used to arrange pieces of the Views that represent the child elements. This methods returns the view responsible for the child element index (prior to breaking). These are the Views that were produced from a factory (to represent the child elements) and used for layout.

### adjustRow

    protected void adjustRow(javax.swing.text.ParagraphView.Row r,
                             int desiredSpan,
                             int x)

  Adjusts the given row if possible to fit within the layout span. By default this will try to find the highest break weight possible nearest the end of the row. If a forced break is encountered, the break will be positioned there.
  Parameters:
    `r` - the row to adjust to the current layout span.
    `desiredSpan` - the current layout span >= 0
    `x` - the location r starts at.

### getNextNorthSouthVisualPositionFrom

    protected int getNextNorthSouthVisualPositionFrom(int pos,
                                                      Position.Bias b,
                                                      Shape a,
                                                      int direction,
                                                      Position.Bias[] biasRet)
                                               throws BadLocationException

  Overriden from CompositeView.
  Overrides:
    `getNextNorthSouthVisualPositionFrom` in class `CompositeView`
  Following copied from class: `javax.swing.text.CompositeView`
  Returns:
    next position west of the passed in position.

### getClosestPositionTo

    protected int getClosestPositionTo(int pos,
                                       Position.Bias b,
                                       Shape a,
                                       int direction,
                                       Position.Bias[] biasRet,
                                       int rowIndex,
                                       int x)
                                throws BadLocationException

  Returns the closest model position to `x`. `rowIndex` gives the index of the view that corresponds that should be looked in.

### flipEastAndWestAtEnds

    protected boolean flipEastAndWestAtEnds(int position,
                                            Position.Bias bias)

  Description copied from class: `CompositeView`
  Subclasses may wish to subclass this and conditionally return true based on the position. A return value of true indicates that when a View returns -1 from getNextVisualPositionFrom the next view for east should be the current index offset by -1, and for west it means offset by 1. The normal direction (for left to right text) is to offset east by 1 and west by -1.
  Overrides:
    `flipEastAndWestAtEnds` in class `BoxView`
  Following copied from class: `javax.swing.text.CompositeView`
  Returns:
    false

### getFlowSpan

    public int getFlowSpan(int index)

  Fetch the constraining span to flow against for the given child index.
  Overrides:
    `getFlowSpan` in class `FlowView`
  Following copied from class: `javax.swing.text.FlowView`
  Parameters:
    `index` - the index of the row being updated. This should be a value >= 0 and < getViewCount().
  See Also:
    `FlowView.getFlowStart(int)`

### getFlowStart

    public int getFlowStart(int index)

  Fetch the location along the flow axis that the flow span will start at.
  Overrides:
    `getFlowStart` in class `FlowView`
  Following copied from class: `javax.swing.text.FlowView`
  Parameters:
    `index` - the index of the row being updated. This should be a value >= 0 and < getViewCount().
  See Also:
    `FlowView.getFlowSpan(int)`

### createRow

    protected View createRow()

  Create a View that should be used to hold a a rows worth of children in a flow.
  Overrides:
    `createRow` in class `FlowView`

### nextTabStop

    public float nextTabStop(float x,
                             int tabOffset)

  Returns the next tab stop position given a reference position. This view implements the tab coordinate system, and calls `getTabbedSpan` on the logical children in the process of layout to determine the desired span of the children. The logical children can delegate their tab expansion upward to the paragraph which knows how to expand tabs. `LabelView` is an example of a view that delegates its tab expansion needs upward to the paragraph.

  This is implemented to try and locate a `TabSet` in the paragraph element's attribute set. If one can be found, its settings will be used, otherwise a default expansion will be provided. The base location for for tab expansion is the left inset from the paragraphs most recent allocation (which is what the layout of the children is based upon).

  Specified by:
    `nextTabStop` in interface `TabExpander`
  Parameters:
    `x` - the X reference position
    `tabOffset` - the position within the text stream that the tab occurred at >= 0.
  Returns:
    the trailing end of the tab expansion >= 0
  See Also:
    `TabSet`, `TabStop`, `LabelView`

### getTabSet

    protected TabSet getTabSet()

  Gets the Tabset to be used in calculating tabs.
  Returns:
    the TabSet

### getPartialSize

    protected float getPartialSize(int startOffset,
                                   int endOffset)

  Returns the size used by the views between `startOffset` and `endOffset`. This uses getPartialView to calculate the size if the child view implements the TabableView interface. If a size is needed and a View does not implement the TabableView interface, the preferredSpan will be used.
  Parameters:
    `startOffset` - the starting document offset >= 0
    `endOffset` - the ending document offset >= startOffset
  Returns:
    the size >= 0

### findOffsetToCharactersInString

    protected int findOffsetToCharactersInString(char[] string,
                                                 int start)

  Finds the next character in the document with a character in `string`, starting at offset `start`. If there are no characters found, -1 will be returned.
  Parameters:
    `string` - the string of characters
    `start` - where to start in the model >= 0
  Returns:
    the document offset or -1

### getTabBase

    protected float getTabBase()

  Returns:
    where tabs are calculated from.

### paint

    public void paint(Graphics g,
                      Shape a)

  Renders using the given rendering surface and area on that surface. This is implemented to delgate to the superclass after stashing the base coordinate for tab calculations.
  Overrides:
    `paint` in class `BoxView`
  Parameters:
    `g` - the rendering surface to use
    `a` - the allocated region to render into
  See Also:
    `View.paint(java.awt.Graphics, java.awt.Shape)`

### getAlignment

    public float getAlignment(int axis)

  Determines the desired alignment for this view along an axis. This is implemented to give the alignment to the center of the first row along the y axis, and the default along the x axis.
  Overrides:
    `getAlignment` in class `BoxView`
  Parameters:
    `axis` - may be either View.X_AXIS or View.Y_AXIS

### breakView

    public View breakView(int axis,
                          float len,
                          Shape a)

  Breaks this view on the given axis at the given length.

  ParagraphView instances are breakable along the Y_AXIS only, and only if `len` is after the first line.

  Parameters:
    `axis` - may be either View.X_AXIS or View.Y_AXIS
    `len` - specifies where a potential break is desired along the given axis >= 0
    `a` - the current allocation of the view
  Returns:
    the fragment of the view that represents the given span, if the view can be broken. If the view doesn't support breaking behavior, the view itself is returned.
  See Also:
    `View.breakView(int, int, float, float)`

### getBreakWeight

    public int getBreakWeight(int axis,
                              float len)

  Gets the break weight for a given location. ParagraphView instances are breakable along the Y_AXIS only, and only if `len` is after the first row. If the length is less than one row, a value of BadBreakWeight is returned.
  Parameters:
    `axis` - may be either View.X_AXIS or View.Y_AXIS
    `len` - specifies where a potential break is desired >= 0
  Returns:
    a value indicating the attractiveness of breaking here
  See Also:
    `View.getBreakWeight(int, float, float)`

### changedUpdate

    public void changedUpdate(DocumentEvent changes,
                              Shape a,
                              ViewFactory f)

  Gives notification from the document that attributes were changed in a location that this view is responsible for.
  Overrides:
    `changedUpdate` in class `FlowView`
  Parameters:
    `changes` - the change information from the associated document
    `a` - the current allocation of the view
    `f` - the factory to use to rebuild if the view has children
  See Also:
    `View.changedUpdate(javax.swing.event.DocumentEvent, java.awt.Shape, javax.swing.text.ViewFactory)`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.